Module java.desktop
Package javax.swing.plaf

## Class ListUI

- java.lang.Object
- - javax.swing.plaf.ComponentUI
  - - javax.swing.plaf.ListUI

Direct Known Subclasses:
  `BasicListUI`, `MultiListUI`

    public abstract class ListUI
    extends ComponentUI

The `JList` pluggable look and feel delegate.

### Constructor Summary

Constructors
`ListUI()`

### Method Summary

All Methods Instance Methods Abstract Methods
`abstract Rectangle` `getCellBounds​(JList<?> list, int index1, int index2)` Returns the bounding rectangle, in the given list's coordinate system, for the range of cells specified by the two indices.
`abstract Point` `indexToLocation​(JList<?> list, int index)` Returns the origin in the given `JList`, of the specified item, in the list's coordinate system.
`abstract int` `locationToIndex​(JList<?> list, Point location)` Returns the cell index in the specified `JList` closest to the given location in the list's coordinate system.

### Methods declared in class javax.swing.plaf.ComponentUI

`contains, createUI, getAccessibleChild, getAccessibleChildrenCount, getBaseline, getBaselineResizeBehavior, getMaximumSize, getMinimumSize, getPreferredSize, installUI, paint, uninstallUI, update`

### Methods declared in class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ListUI

    public ListUI()

### Method Detail

#### locationToIndex

    public abstract int locationToIndex​(JList<?> list,
                                        Point location)

Returns the cell index in the specified `JList` closest to the given location in the list's coordinate system. To determine if the cell actually contains the specified location, compare the point against the cell's bounds, as provided by `getCellBounds`. This method returns `-1` if the list's model is empty.

Parameters:
  `list` - the list
  `location` - the coordinates of the point
Returns:
  the cell index closest to the given location, or `-1`
Throws:
  `NullPointerException` - if `location` is null

#### indexToLocation

    public abstract Point indexToLocation​(JList<?> list,
                                          int index)

Returns the origin in the given `JList`, of the specified item, in the list's coordinate system. Returns `null` if the index isn't valid.

Parameters:
  `list` - the list
  `index` - the cell index
Returns:
  the origin of the cell, or `null`

#### getCellBounds

    public abstract Rectangle getCellBounds​(JList<?> list,
                                            int index1,
                                            int index2)

Returns the bounding rectangle, in the given list's coordinate system, for the range of cells specified by the two indices. The indices can be supplied in any order.

If the smaller index is outside the list's range of cells, this method returns `null`. If the smaller index is valid, but the larger index is outside the list's range, the bounds of just the first index is returned. Otherwise, the bounds of the valid range is returned.

Parameters:
  `list` - the list
  `index1` - the first index in the range
  `index2` - the second index in the range
Returns:
  the bounding rectangle for the range of cells, or `null`